//+------------------------------------------------------------------+
//|                                ^X_ParabolicRegression_Custom.mq4 |
//|                                                    Version 1.3.6 |
//|                                                                  |
//|                     Copyright  2007, Mr.WT, Senior Linux Hacker |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Mr.WT, Senior Linux Hacker"
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window

extern int _Small_Period = 34;
extern int _Big_Period = 144;
extern int _RegressionDegree = 2;
extern color _TrendLineColor = DeepSkyBlue;
extern int LR_WIDTH = 1;
extern color _TrendLineColor2 = Magenta;
extern int LR2_WIDTH = 1;
extern color _RegressionColor1 = Magenta;
extern color _RegressionColor2 = Magenta;
extern color _RegressionColor3 = Magenta;
extern color _RegressionColor4 = Magenta;
extern double _K_N.L.Dev = 2.72;
//------------------------------------------
double fx,fx1;
double a[10,10],b[10],x[10],sx[20];
double sum,sum1,sq; 
int p,p1,p2,nn,kt;
//---------------------
int i0,ip,pn,i0n,ipn;
int t0,tp,te,te1;
int _N_Time, _Cur_Period;
string str;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//----
p=_Small_Period; p1=_Big_Period; p2=_Small_Period;
str=p2+","+p1+","+_RegressionDegree+","+DoubleToStr(_K_N.L.Dev,3);
IndicatorShortName("X_ParabolicRegression_v1.3.6("+str+")");
//--- too small history
if(p>Bars) {
  Comment("\n\n                    ERROR - TOO SMALL HISTORY, RETURN NOW!");
  return(-1); // then exit
}

//----------------------ar------------------------------
  kt=Period()*60;
  nn=_RegressionDegree+1; 
  //----------------------
  t0=Time[0];
  i0=iBarShift(Symbol(),Period(),t0);
  ip=i0+p;
  tp=Time[ip];
  pn=p;
  //----------------------ar------------------------------
  for (int j=-p/2; j<p; j++)
  {
    ObjectCreate("ar("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0); 
    ObjectSet("ar("+str+")"+j,OBJPROP_RAY,0);  
    ObjectCreate("arH("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0); 
    ObjectSet("arH("+str+")"+j,OBJPROP_RAY,0);
    ObjectCreate("arL("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0); 
    ObjectSet("arL("+str+")"+j,OBJPROP_RAY,0);  
  }
  //----------------------LR------------------------------
  ObjectCreate("LR("+str+")",4,0,Time[0],0,Time[0],0);
  ObjectSet("LR("+str+")",OBJPROP_COLOR,_TrendLineColor); 
  ObjectSet("LR("+str+")",OBJPROP_RAY,1);
  ObjectSet("LR("+str+")",OBJPROP_STYLE,STYLE_DASH);
  ObjectSet("LR("+str+")",OBJPROP_WIDTH,LR_WIDTH);

  ObjectCreate("LR("+str+")2",4,0,Time[0],0,Time[0],0);
  ObjectSet("LR2("+str+")",OBJPROP_COLOR,_TrendLineColor2); 
  ObjectSet("LR2("+str+")",OBJPROP_RAY,1);
  ObjectSet("LR2("+str+")",OBJPROP_STYLE,STYLE_DASH);
  ObjectSet("LR2("+str+")",OBJPROP_WIDTH,LR2_WIDTH);
//----
_N_Time = 0;
_Cur_Period = 0;
return(0);
}

int deinit() {
  for (int j=p; j>=-p/2; j--)
  { 
    ObjectDelete("ar("+str+")"+j);
    ObjectDelete("arH("+str+")"+j);
    ObjectDelete("arL("+str+")"+j);
  }
  ObjectDelete("LR("+str+")");
  ObjectDelete("LR2("+str+")");
  Comment("");
return(0);
}

//+------------------------------------------------------------------+

int start() {

if( _N_Time != Time[0] || _Cur_Period != Period() ) {
//=================================================================
  int i,n,k;
  //---- 
    if (i0n!=i0 || ipn!=ip)
    {
      p=ip-i0;
      i0n=ip;
      ipn=ip;
      //--------------------------------------------------------
      if (pn<p)
      {
        for(int j=pn; j<=p; j++) {
          ObjectCreate("ar("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0);
          ObjectSet("ar("+str+")"+j,OBJPROP_RAY,0);
          ObjectCreate("arH("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0);
          ObjectSet("arH("+str+")"+j,OBJPROP_RAY,0);
          ObjectCreate("arL("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0);
          ObjectSet("arL("+str+")"+j,OBJPROP_RAY,0);
        }  
        
        for (j=-pn/2; j>=-p/2; j--) {
          ObjectCreate("ar("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0); 
          ObjectSet("ar("+str+")"+j,OBJPROP_RAY,0); 
          ObjectCreate("arH("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0); 
          ObjectSet("arH("+str+")"+j,OBJPROP_RAY,0); 
          ObjectCreate("arL("+str+")"+j,2,0,Time[i0+1+j],0,Time[i0+j],0); 
          ObjectSet("arL("+str+")"+j,OBJPROP_RAY,0);
        } 
        pn=p;    
      }
      if (pn>p)
      {
        for(j=pn; j>=p; j--) {
          ObjectDelete("ar("+str+")"+j); 
          ObjectDelete("arH("+str+")"+j); 
          ObjectDelete("arL("+str+")"+j);
        }
        
        for (j=-p/2; j>=-pn/2; j--) {
          ObjectDelete("ar("+str+")"+j); 
          ObjectDelete("arH("+str+")"+j); 
          ObjectDelete("arL("+str+")"+j);
        }   
        pn=p;
      }
    }
    //======================PR================================================
    sx[1]=p+1;
    //----------------------sx------------------------------------------------
    for(i=1; i<=nn*2-2; i++) 
    {
      sum=0.0; 
      for(n=i0; n<=i0+p; n++) sum+=MathPow(n,i); 
      sx[i+1]=sum;
    }  
    //----------------------syx-----------------------------------------------
    for(i=1; i<=nn; i++) 
    {
      sum=0.0; 
      for(n=i0; n<=i0+p; n++) 
      {
        if (i==1) sum+=Close[n]; 
        else 
        sum+=Close[n]*MathPow(n,i-1);
      } 
      b[i]=sum;
    } 
    //===============Matrix==================================================
    for(j=1; j<=nn; j++) 
    {
      for(i=1; i<=nn; i++) {k=i+j-1; a[i,j]=sx[k];}
    }  
    //===============Gauss===================================================
    af_Gauss(nn,a,b,x);
    //=======================SQ==============================================
    sq=0.0;
    for (n=p; n>=0; n--)
    {
      sum=0.0;
      for(k=1; k<=_RegressionDegree; k++) {
        sum+=x[k+1]*MathPow(i0+n,k); 
        sum1+=x[k+1]*MathPow(i0+n+1,k);
      }
      fx=x[1]+sum;
      sq+=MathPow(Close[n+i0]-fx,2);
    }
    sq = _K_N.L.Dev * MathSqrt(sq/(p+1));
   //---
   ObjectMove("LR("+str+")", 0, Time[p1],0);
   ObjectMove("LR("+str+")", 1, Time[1],0);
  if (p2 != 0) {
   ObjectMove("LR2("+str+")", 0, Time[p2],0);
   ObjectMove("LR2("+str+")", 1, Time[1],0);
  }
   //---
//=======================================================================
    for (n=p; n>=-p/2; n--) 
    {
      sum=0.0; 
      sum1=0.0; 
      for(k=1; k<=_RegressionDegree; k++) {
        sum+=x[k+1]*MathPow(i0+n,k); 
        sum1+=x[k+1]*MathPow(i0+n+1,k);
      }  
      fx=x[1]+sum;
      fx1=x[1]+sum1;
        
      if (n>=0 && n<p)
      {
        ObjectMove("ar("+str+")"+n,0,Time[n+i0+1],fx1); 
        ObjectMove("ar("+str+")"+n,1,Time[n+i0],fx);
        ObjectMove("arH("+str+")"+n,0,Time[n+i0+1],fx1+sq); 
        ObjectMove("arH("+str+")"+n,1,Time[n+i0],fx+sq);
        ObjectMove("arL("+str+")"+n,0,Time[n+i0+1],fx1-sq); 
        ObjectMove("arL("+str+")"+n,1,Time[n+i0],fx-sq);
        
        if (fx>fx1) {
          ObjectSet("ar("+str+")"+n,OBJPROP_COLOR,_RegressionColor1); 
          ObjectSet("arH("+str+")"+n,OBJPROP_COLOR,_RegressionColor1); 
          ObjectSet("arL("+str+")"+n,OBJPROP_COLOR,_RegressionColor1);
        }
        if (fx<fx1) {
          ObjectSet("ar("+str+")"+n,OBJPROP_COLOR,_RegressionColor2); 
          ObjectSet("arH("+str+")"+n,OBJPROP_COLOR,_RegressionColor2); 
          ObjectSet("arL("+str+")"+n,OBJPROP_COLOR,_RegressionColor2);
        }  
      }
        
      if (n<0)
      {
        if ((n+i0)>=0) 
        {
          ObjectMove("ar("+str+")"+n,0,Time[n+i0+1],fx1); 
          ObjectMove("ar("+str+")"+n,1,Time[n+i0],fx);
          ObjectMove("arH("+str+")"+n,0,Time[n+i0+1],fx1+sq); 
          ObjectMove("arH("+str+")"+n,1,Time[n+i0],fx+sq);
          ObjectMove("arL("+str+")"+n,0,Time[n+i0+1],fx1-sq); 
          ObjectMove("arL("+str+")"+n,1,Time[n+i0],fx-sq);
        }
        if ((n+i0)<0) 
        {
          te=Time[0]-(n+i0)*kt; 
          te1=Time[0]-(n+i0+1)*kt;
          ObjectMove("ar("+str+")"+n,0,te1,fx1); 
          ObjectMove("ar("+str+")"+n,1,te,fx);
          ObjectMove("arH("+str+")"+n,0,te1,fx1+sq); 
          ObjectMove("arH("+str+")"+n,1,te,fx+sq);
          ObjectMove("arL("+str+")"+n,0,te1,fx1-sq); 
          ObjectMove("arL("+str+")"+n,1,te,fx-sq);
        } 
        
        if (fx>fx1) {
          ObjectSet("ar("+str+")"+n,OBJPROP_COLOR,_RegressionColor3); 
          ObjectSet("arH("+str+")"+n,OBJPROP_COLOR,_RegressionColor3); 
          ObjectSet("arL("+str+")"+n,OBJPROP_COLOR,_RegressionColor3);
        }
        if (fx<fx1) {
          ObjectSet("ar("+str+")"+n,OBJPROP_COLOR,_RegressionColor4); 
          ObjectSet("arH("+str+")"+n,OBJPROP_COLOR,_RegressionColor4); 
          ObjectSet("arL("+str+")"+n,OBJPROP_COLOR,_RegressionColor4);
        }
      }
    }
//=================================================================
_N_Time = Time[0];
_Cur_Period = Period();
}//main if()
return(0);
}//end of program
//+------------------------------------------------------------------+

void af_Gauss(int n, double& a[][],double& b[], double& x[]) {
  int i,j,k,l;
  double q,m,t;

  for(k=1; k<=n-1; k++) 
  {
    l=0; 
    m=0; 
    for(i=k; i<=n; i++) 
    {
      if (MathAbs(a[i,k])>m) {m=MathAbs(a[i,k]); l=i;}
    } 
    if (l==0) return(0);   

    if (l!=k) 
    {
      for(j=1; j<=n; j++) 
      {
        t=a[k,j]; 
        a[k,j]=a[l,j]; 
        a[l,j]=t;
      } 
      t=b[k]; 
      b[k]=b[l]; 
      b[l]=t;
    }  

    for(i=k+1;i<=n;i++) 
    {
      q=a[i,k]/a[k,k]; 
      for(j=1;j<=n;j++) 
      {
        if (j==k) a[i,j]=0; 
        else 
        a[i,j]=a[i,j]-q*a[k,j];
      } 
      b[i]=b[i]-q*b[k];
    }
  }  
  
  x[n]=b[n]/a[n,n]; 
  
  for(i=n-1;i>=1;i--) 
  {
    t=0; 
    for(j=1;j<=n-i;j++) 
    {
      t=t+a[i,i+j]*x[i+j]; 
      x[i]=(1/a[i,i])*(b[i]-t);
    }
  }
}
//===========================================================================

